package org.geek.szbay.assistant.code.generator;

import java.util.List;

import org.geek.szbay.assistant.code.generator.helpper.MakeHelpper;
import org.geek.szbay.assistant.code.generator.helpper.TableHelpper;
import org.geek.szbay.assistant.utils.StringUtils;

/**
 * @author wutianbin
 * @Time：2017年5月18日 下午7:31:51
 * @version 1.0
 */
public class DaoMysqlMaker {

    /** 
     * 功能：生成实体类主体代码 
     * @param colnames 
     * @param colTypes 
     * @param colSizes 
     * @return 
     */  
    public static final String parse(String authorName, String className, 
            String tableName, String tableComment, String key, String outPath, 
            String entityFullClassName, String entityClassName,
            List<String> attrNames, 
            List<String> colNames, List<String> colTypes, List<String> colComments) {  
        StringBuffer sb = new StringBuffer();  
          
        sb.append("package " + outPath + ";\r\n");  
        sb.append("\r\n");  
        
        //if ("id".equals(key.toLowerCase())) {
        	// 主键是id
        	sb.append(inner_parse_with_id(authorName, className, tableName, tableComment,
        			key, outPath, entityFullClassName,
                    entityClassName, attrNames, colNames, colTypes, colComments));
        //} else {
        	// 主键不是id
        //	sb.append(inner_parse_not_id(authorName, className, tableName, tableComment, 
        //            key, outPath, entityFullClassName,
        //            entityClassName, attrNames, colNames, colTypes, colComments));
        //}
        sb.append("    // 非常规sql写这里--- xml 自动生成,不再手动在xml中写sql !! \r\n"); 
        sb.append("\r\n");

        sb.append("}\r\n");  

        return sb.toString();  
    }
    
    public static final String inner_parse_not_id(String authorName, String className, 
            String tableName, String tableComment, String key, String outPath, 
            String entityFullClassName, String entityClassName,
            List<String> attrNames, 
            List<String> colNames, List<String> colTypes, List<String> colComments) {  
    	StringBuffer sb = new StringBuffer(); 
    	
        sb.append("import java.util.List;\r\n");
        sb.append("\r\n");  
        sb.append("import org.apache.ibatis.annotations.Mapper;\r\n");
        sb.append("import org.apache.ibatis.annotations.Param;\r\n");
        sb.append("\r\n");  
        
        sb.append("import " + entityFullClassName + ";\r\n");
        sb.append("\r\n");  

        //注释部分  
        sb.append(MakeHelpper.makeClassComments(tableComment + "(" + tableName + ") 实体类的Dao", authorName));
        
        //实体部分  
        sb.append("@Mapper \r\n");
        sb.append("public interface " + className).append(" {\r\n");
        sb.append("\r\n");

        if (key != null && !key.trim().equals("")) {
            String keyAttr = TableHelpper.columnNameToAttrName(key);
            
            sb.append("    public " + entityClassName + " getBy" + StringUtils.firstToUpperCase(keyAttr))
                .append("(@Param(\"" + keyAttr + "\") ").append("Long ").append(keyAttr + ");\r\n"); 
            sb.append("\r\n");
        }
        
        sb.append("    public int save(" + entityClassName + " t);\r\n"); 
        sb.append("\r\n");
        
        sb.append("    public int update(" + entityClassName + " t);\r\n"); 
        sb.append("\r\n");

        sb.append("    public int countByExample(@Param(\"example\") " + entityClassName + " example);\r\n"); 
        sb.append("\r\n");

        sb.append("    public List< " + entityClassName + "> listByExample(@Param(\"page\") Integer page,\r\n")
        	.append("        @Param(\"pageSize\") Integer pageSize,\r\n")
        	.append("        @Param(\"example\") " + entityClassName + " example);\r\n"); 
        sb.append("\r\n");

        sb.append("    public int updateByExample(@Param(\"update\") " + entityClassName + " update, \r\n")
        	.append("        @Param(\"example\") " + entityClassName + " example);\r\n");
        sb.append("\r\n");
        
        return sb.toString();
    }
    
    public static final String inner_parse_with_id(String authorName, String className, 
            String tableName, String tableComment, String key, String outPath, 
            String entityFullClassName, String entityClassName,
            List<String> attrNames, 
            List<String> colNames, List<String> colTypes, List<String> colComments) {  
    	StringBuffer sb = new StringBuffer(); 
    	
        sb.append("import org.apache.ibatis.annotations.Mapper;\r\n");
        sb.append("\r\n");  
        
        sb.append("import " + entityFullClassName + ";\r\n");
        sb.append("\r\n");  

        //注释部分  
        sb.append(MakeHelpper.makeClassComments(tableComment + "(" + tableName + ") 实体类的Dao", authorName));
        
        //实体部分  
        sb.append("@Mapper \r\n");
        sb.append("public interface " + className)
        	.append(" extends BaseDao<").append(entityClassName).append("> {\r\n");
        sb.append("\r\n");
        
        return sb.toString();
    }
    
}
