package org.geek.szbay.assistant.code.generator;

import java.util.List;

import org.geek.szbay.assistant.code.generator.helpper.MakeHelpper;
import org.geek.szbay.assistant.code.generator.helpper.TableHelpper;
import org.geek.szbay.assistant.utils.StringUtils;

/**
 * @author wutianbin
 * @Time：2017年5月18日 下午7:31:51
 * @version 1.0
 */
public class ReaderMysqlMaker {

    /** 
     * 功能：生成实体类主体代码 
     * @param colnames 
     * @param colTypes 
     * @param colSizes 
     * @return 
     */  
    public static final String parse(String authorName, String className, 
            String tableName, String key, String outPath, String entityFullClassName,
            String entityClassName,
            List<String> attrNames, 
            List<String> colNames, List<String> colTypes, List<String> colComments) {  
        StringBuffer sb = new StringBuffer();  
          
        sb.append("package " + outPath + ";\r\n");  
        sb.append("\r\n");  
        sb.append("import org.apache.ibatis.annotations.Param;\r\n");
        sb.append("\r\n");  
        sb.append("import " + entityFullClassName + ";\r\n");
        sb.append("\r\n");  

        //注释部分  
        sb.append(MakeHelpper.makeClassComments(tableName + " 实体类的读取器", authorName));
        
        //实体部分  
        sb.append("public interface " + className + " {\r\n");
        sb.append("\r\n");
        
        if (key != null && !key.trim().equals("")) {
            String keyAttr = TableHelpper.columnNameToAttrName(key);
            
            sb.append("    public " + entityClassName + " getBy" + StringUtils.firstToUpperCase(keyAttr))
                .append("(@Param(\"" + keyAttr + "\") ").append("Long ").append(keyAttr + ");\r\n"); 
            sb.append("\r\n");
        }
        
        sb.append("}\r\n");  

        return sb.toString();  
    }
    
}
