package org.geek.szbay.assistant.code.generator;

import java.util.List;

import org.geek.szbay.assistant.code.generator.helpper.MakeHelpper;
import org.geek.szbay.assistant.utils.StringUtils;

/**
 * @author wutianbin
 * @Time：2017年5月18日 下午7:31:51
 * @version 1.0
 */
public class ServiceImplMysqlMaker {

    /** 
     * 功能：生成实体类主体代码 
     * @param colnames 
     * @param colTypes 
     * @param colSizes 
     * @return 
     */  
    public static final String parse(String authorName, String className, 
            String tableName, String tableComment, String key, String outPath, 
            String entityFullClassName, String entityClassName,
            String daoFullClassName, String daoClassName,
            String serviceFullClassName, String serviceClassName,
            List<String> attrNames, 
            List<String> colNames, List<String> colTypes, List<String> colComments) {  
        StringBuffer sb = new StringBuffer();  
          
        sb.append("package " + outPath + ";\r\n");  
        sb.append("\r\n");  
        
        sb.append("import org.springframework.beans.factory.annotation.Autowired;\r\n");
        sb.append("import org.springframework.stereotype.Service;\r\n");
        sb.append("\r\n");  
        
        sb.append("import " + daoFullClassName + ";\r\n");
        sb.append("import " + serviceFullClassName + ";\r\n");
        sb.append("import " + entityFullClassName + ";\r\n");
        sb.append("\r\n");  
        
        //注释部分  
        sb.append(MakeHelpper.makeClassComments(tableComment + "(" + tableName + ") 实体类的数据服务类实现", authorName));

        sb.append("@Service\r\n");
        
        //实体部分 
        sb.append("public class ").append(className)
        	.append(" extends BaseServiceImpl<").append(entityClassName).append(">\r\n")
        	.append("        implements ").append(serviceClassName)
        	.append(" {\r\n");
        sb.append("\r\n");
        
        String daoObject = StringUtils.firstToLowerCase(daoClassName);
        sb.append("    @Autowired \r\n");
        sb.append("    private ").append(daoClassName).append(" ").append(daoObject).append(";\r\n");
        sb.append("\r\n");
        
        sb.append("}\r\n");  

        return sb.toString();  
    }

}
