package org.geek.szbay.assistant.code.generator.helpper;

import org.geek.szbay.assistant.utils.CharUtils;

/**
 * @author wutianbin
 * @Time：2017年5月18日 下午10:19:00
 * @version 1.0
 */
public class TableHelpper {
    
    public final static String tableNameToClassName(String tableName) {  
        char[] ch = tableName.toCharArray();
        
        ch[0] = CharUtils.toUpperChar(ch[0]);

        StringBuffer sb = new StringBuffer();
        
        boolean toUpper = false;
        
        for(char c : ch) {
            if (c == '_') {
                toUpper = true;
            } else {
                if (toUpper) {
                    c = CharUtils.toUpperChar(c);
                    toUpper = false;
                }
                
                sb.append(c);
            }
        }
        
        return sb.toString();  
    }  

    public final static String columnNameToAttrName(String columnName) {  
        char[] ch = columnName.toCharArray();
        
        ch[0] = CharUtils.toLowerChar(ch[0]);

        StringBuffer sb = new StringBuffer();
        
        boolean toUpper = false;
        
        for(char c : ch) {
            if (c == '_') {
                toUpper = true;
            } else {
                if (toUpper) {
                    c = CharUtils.toUpperChar(c);
                    toUpper = false;
                }
                
                sb.append(c);
            }
        }
        
        return sb.toString();  
    }  

    /** 
     * 功能：获得列的数据类型 
     * @param sqlType 
     * @return 
     */  
    public final static String sqlTypeToJavaType(String sqlType) {
        if(sqlType.equalsIgnoreCase("bit")){  
            return "Boolean";  
        }else if(sqlType.equalsIgnoreCase("year")){  
            return "Integer";  
        }else if(sqlType.equalsIgnoreCase("tinyint")){  
            return "Integer";  
        }else if(sqlType.equalsIgnoreCase("smallint")){  
            return "Integer";  
        }else if(sqlType.equalsIgnoreCase("int")){  
            return "Integer";  
        }else if(sqlType.equalsIgnoreCase("bigint")){  
            return "Long";  
        }else if(sqlType.equalsIgnoreCase("float")){  
            return "Float";  
        }else if(sqlType.equalsIgnoreCase("decimal") || sqlType.equalsIgnoreCase("numeric")   
                || sqlType.equalsIgnoreCase("real") || sqlType.equalsIgnoreCase("money")   
                || sqlType.equalsIgnoreCase("smallmoney") || sqlType.equalsIgnoreCase("double")){  
            return "Double";  
        }else if(sqlType.equalsIgnoreCase("varchar") || sqlType.equalsIgnoreCase("char")   
                || sqlType.equalsIgnoreCase("nvarchar") || sqlType.equalsIgnoreCase("nchar")   
                || sqlType.equalsIgnoreCase("text") || sqlType.equalsIgnoreCase("longtext")){  
            return "String";  
        }else if(sqlType.equalsIgnoreCase("datetime") || sqlType.equalsIgnoreCase("date")
                || sqlType.equalsIgnoreCase("timestamp") || sqlType.equalsIgnoreCase("time")){  
            return "Date";  
        }else if(sqlType.equalsIgnoreCase("image") || sqlType.equalsIgnoreCase("blob")
                || sqlType.equalsIgnoreCase("longbolb") || sqlType.equalsIgnoreCase("mediumttext")){  
            return "Blob";  
        }  

        return null;  
    }  

}
