package org.geek.szbay.assistant.utils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * 日期的相关工具
 * 
 * @author wutianbin
 * @Time：2017年5月14日 下午1:12:05
 * @version 1.0
 */
public class DateUtils {

    private final static String DATETIME_FORMAT = "yyyy-MM-dd HH:mm:ss";
    
    /**
     * 获取到当前时间的字符串，默认格式为"yyyy-MM-dd HH:mm:ss"
     *nowDatetimeString:(). 
      * @author wutianbin 
     * @return
     */
    public final static String nowDatetimeString() {
        // 设置日期格式
        SimpleDateFormat df = new SimpleDateFormat(DATETIME_FORMAT);
        return df.format(new Date());    
    }
    
    public final static Date stringToDatetime(String value) {
        if (value == null) {
            return null;
        }
        
        SimpleDateFormat df = new SimpleDateFormat(DATETIME_FORMAT);
        try {
            return df.parse(value.trim());
        } catch (ParseException e) {
            e.printStackTrace();
        }
        
        return null;
    }
 
    public static Date strToDate(String date, String pattern) {
        SimpleDateFormat formatter = new SimpleDateFormat(pattern);
        formatter.setLenient(false);
        try {
            return formatter.parse(date);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return null;
    }
    
    public static void main(String arg[]) {
        Date receiptTime = strToDate("2016-12-27 23:10:55", "yyyy-MM-dd HH:mm:ss");   
//        Date compTime = strToDate("2016-06-01 00:00:00", "yyyy-MM-dd hh:mm:ss");
        Date compTime = strToDate("2016-06-01 00:00:10", "yyyy-MM-dd HH:mm:ss");
        System.out.println(receiptTime);
        System.out.println(compTime);
//        if (receiptTime.getTime() <= compTime.getTime()) {
//            System.out.println("OK"); 
//        } else {
//            System.out.println("not bad");
//        }
    }
}
